# PhasicFlow: sortedContactList< valueType, executionSpace, idType > Class Template Reference

sortedContactList< valueType, executionSpace, idType > Class Template Reference
Inheritance diagram for sortedContactList< valueType, executionSpace, idType >:
[legend]
Collaboration diagram for sortedContactList< valueType, executionSpace, idType >:
[legend]

## Classes

class | TagReFillPairs

## Public Types

using | SortedPairs = sortedPairs< executionSpace, idType >
using | ValueType = valueType
using | IdType = typename SortedPairs::IdType
using | ExecutionSpace = typename SortedPairs::ExecutionSpace
using | memory_space = typename SortedPairs::memory_space
using | PairType = typename SortedPairs::PairType
using | ContainerType = typename SortedPairs::ContainerType
Public Types inherited from sortedPairs< executionSpace, idType >
using | UnsortedPairs = unsortedPairs< executionSpace, idType >
using | IdType = typename UnsortedPairs::IdType
using | ExecutionSpace = typename UnsortedPairs::ExecutionSpace
using | memory_space = typename ExecutionSpace::memory_space
using | PairType = typename UnsortedPairs::PairType
using | ContainerType = typename UnsortedPairs::ContainerType
Public Types inherited from unsortedPairs< executionSpace, idType >
using | UnsortedPairs = unsortedPairs< executionSpace, idType >
using | IdType = idType
using | ExecutionSpace = executionSpace
using | memory_space = typename ExecutionSpace::memory_space
using | PairType = kPair< idType, idType >
using | ContainerType = unorderedSet< PairType, ExecutionSpace >

## Public Member Functions

| TypeInfoNV ("sortedContactList")
| sortedContactList (int32 initialSize=1)
bool | beforeBroadSearch ()
bool | afterBroadSearch ()
INLINE_FUNCTION_HD ValueType | getValue (int32 idx) const
INLINE_FUNCTION_HD void | setValue (int32 idx, const ValueType &val) const
INLINE_FUNCTION_HD void | operator() (TagReFillPairs, int32 idx) const
Public Member Functions inherited from sortedPairs< executionSpace, idType >
| TypeInfoNV ("sortedPairs")
| sortedPairs (int32 initialSize=1)
bool | beforeBroadSearch ()
bool | afterBroadSearch ()
INLINE_FUNCTION_HD PairType | getPair (int32 idx) const
INLINE_FUNCTION_HD bool | getPair (int32 idx, PairType &p) const
INLINE_FUNCTION_HD bool | isValid (int32 idx) const
INLINE_FUNCTION_H int32 | size () const
int32 | loopCount () const
pairAccessor | getPairs () const
INLINE_FUNCTION_H void | clear ()
void | prepareSorted ()
INLINE_FUNCTION_HD void | operator() (TagFillFlag, int32 i) const
INLINE_FUNCTION_HD void | operator() (TagFillPairs, int32 i) const
Public Member Functions inherited from unsortedPairs< executionSpace, idType >
| TypeInfoNV ("unsorderedPairs")
| unsortedPairs (int32 capacity=1)
bool | beforeBroadSearch ()
bool | afterBroadSearch ()
INLINE_FUNCTION_HD int32 | insert (idType i, idType j) const
INLINE_FUNCTION_HD int32 | insert (const PairType &p) const
INLINE_FUNCTION_HD PairType | getPair (int32 idx) const
INLINE_FUNCTION_HD bool | getPair (int32 idx, PairType &p) const
INLINE_FUNCTION_HD int32 | find (const PairType &p) const
INLINE_FUNCTION_HD bool | isValid (int32 idx) const
INLINE_FUNCTION_HD int32 | capacity () const
int32 | loopCount () const
INLINE_FUNCTION_H int32 | size () const
pairAccessor | getPairs () const
INLINE_FUNCTION_H void | increaseCapacityBy (int32 len)
| increase the capacity of the container by at-least len the content will be erased. More...
INLINE_FUNCTION_H void | clear ()
const ContainerType & | container () const

## Protected Types

using | rpReFillPairs = Kokkos::RangePolicy< ExecutionSpace, Kokkos::Schedule< Kokkos::Static >, Kokkos::IndexType< int32 >, TagReFillPairs >
Protected Types inherited from sortedPairs< executionSpace, idType >
using | rpFillFlag = Kokkos::RangePolicy< ExecutionSpace, Kokkos::Schedule< Kokkos::Static >, Kokkos::IndexType< int32 >, TagFillFlag >
using | rpFillPairs = Kokkos::RangePolicy< ExecutionSpace, Kokkos::Schedule< Kokkos::Static >, Kokkos::IndexType< int32 >, TagFillPairs >

## Protected Member Functions

void | adjustCapacity ()

## Protected Attributes

ViewType1D< ValueType, ExecutionSpace > | values_
int32 | size0_ = 0
ViewType1D< PairType, ExecutionSpace > | sortedPairs0_
ViewType1D< ValueType, ExecutionSpace > | values0_
Protected Attributes inherited from sortedPairs< executionSpace, idType >
int32 | size_ = 0
| size of pair list More...
ViewType1D< int32, ExecutionSpace > | flags_
ViewType1D< PairType, ExecutionSpace > | sortedPairs_
Protected Attributes inherited from unsortedPairs< executionSpace, idType >
ContainerType | container_

## Detailed Description

### template<typename valueType, typename executionSpace, typename idType>
class pFlow::sortedContactList< valueType, executionSpace, idType >

Definition at line 30 of file sortedContactList.hpp.

## Member Typedef Documentation

## SortedPairs

using SortedPairs = sortedPairs<executionSpace, idType>

Definition at line 36 of file sortedContactList.hpp.

## ValueType

using ValueType = valueType

Definition at line 38 of file sortedContactList.hpp.

## IdType

using IdType = typename SortedPairs::IdType

Definition at line 40 of file sortedContactList.hpp.

## ExecutionSpace

using ExecutionSpace = typename SortedPairs::ExecutionSpace

Definition at line 42 of file sortedContactList.hpp.

## memory_space

using memory_space = typename SortedPairs::memory_space

Definition at line 44 of file sortedContactList.hpp.

## PairType

using PairType = typename SortedPairs::PairType

Definition at line 46 of file sortedContactList.hpp.

## ContainerType

using ContainerType = typename SortedPairs::ContainerType

Definition at line 48 of file sortedContactList.hpp.

## rpReFillPairs

using rpReFillPairs = Kokkos::RangePolicy< ExecutionSpace, Kokkos::Schedule<Kokkos::Static>, Kokkos::IndexType<int32>, TagReFillPairs>

protected

Definition at line 77 of file sortedContactList.hpp.

## Constructor & Destructor Documentation

## sortedContactList()

sortedContactList | ( | int32 | initialSize = `1` | ) |

inline

Definition at line 84 of file sortedContactList.hpp.

## Member Function Documentation

## adjustCapacity()

void adjustCapacity | ( |  | ) |

inlineprotected

Definition at line 63 of file sortedContactList.hpp.

References pFlow::reallocNoInit(), sortedPairs< executionSpace, idType >::size(), and sortedContactList< valueType, executionSpace, idType >::values_.

Referenced by sortedContactList< valueType, executionSpace, idType >::afterBroadSearch().

Here is the call graph for this function:
Here is the caller graph for this function:

## TypeInfoNV()

TypeInfoNV | ( | "sortedContactList< valueType, executionSpace, idType >" |  | ) |

## beforeBroadSearch()

bool beforeBroadSearch | ( |  | ) |

inline

Definition at line 92 of file sortedContactList.hpp.

References sortedPairs< executionSpace, idType >::beforeBroadSearch(), sortedPairs< executionSpace, idType >::size(), sortedContactList< valueType, executionSpace, idType >::sortedPairs0_, sortedPairs< executionSpace, idType >::sortedPairs_, pFlow::swapViews(), sortedContactList< valueType, executionSpace, idType >::values0_, and sortedContactList< valueType, executionSpace, idType >::values_.

Here is the call graph for this function:

## afterBroadSearch()

bool afterBroadSearch | ( |  | ) |

inline

Definition at line 100 of file sortedContactList.hpp.

References sortedContactList< valueType, executionSpace, idType >::adjustCapacity(), sortedPairs< executionSpace, idType >::afterBroadSearch(), and sortedPairs< executionSpace, idType >::size().

Here is the call graph for this function:

## getValue()

INLINE_FUNCTION_HD ValueType getValue | ( | int32 | idx | ) | const

inline

Definition at line 117 of file sortedContactList.hpp.

References sortedContactList< valueType, executionSpace, idType >::values_.

## setValue()

INLINE_FUNCTION_HD void setValue | ( | int32 | idx,
|  | const ValueType & | val
| ) |  | const

inline

Definition at line 123 of file sortedContactList.hpp.

References sortedContactList< valueType, executionSpace, idType >::values_.

## operator()()

INLINE_FUNCTION_HD void operator() | ( | TagReFillPairs | ,
|  | int32 | idx
| ) |  | const

inline

Definition at line 129 of file sortedContactList.hpp.

References pFlow::binarySearch(), pFlow::max(), pFlow::min(), sortedContactList< valueType, executionSpace, idType >::size0_, sortedContactList< valueType, executionSpace, idType >::sortedPairs0_, sortedPairs< executionSpace, idType >::sortedPairs_, sortedContactList< valueType, executionSpace, idType >::values0_, and sortedContactList< valueType, executionSpace, idType >::values_.

Here is the call graph for this function:

## Member Data Documentation

## values_

ViewType1D<ValueType,ExecutionSpace> values_

protected

Definition at line 54 of file sortedContactList.hpp.

Referenced by sortedContactList< valueType, executionSpace, idType >::adjustCapacity(), sortedContactList< valueType, executionSpace, idType >::beforeBroadSearch(), sortedContactList< valueType, executionSpace, idType >::getValue(), sortedContactList< valueType, executionSpace, idType >::operator()(), and sortedContactList< valueType, executionSpace, idType >::setValue().

## size0_

int32 size0_ = 0

protected

Definition at line 56 of file sortedContactList.hpp.

Referenced by sortedContactList< valueType, executionSpace, idType >::operator()().

## sortedPairs0_

ViewType1D<PairType,ExecutionSpace> sortedPairs0_

protected

Definition at line 58 of file sortedContactList.hpp.

Referenced by sortedContactList< valueType, executionSpace, idType >::beforeBroadSearch(), and sortedContactList< valueType, executionSpace, idType >::operator()().

## values0_

ViewType1D<ValueType,ExecutionSpace> values0_

protected

Definition at line 60 of file sortedContactList.hpp.

Referenced by sortedContactList< valueType, executionSpace, idType >::beforeBroadSearch(), and sortedContactList< valueType, executionSpace, idType >::operator()().

The documentation for this class was generated from the following file:

- src/Interaction/contactLists/sortedContactList.hpp